from Products.ZSQLMethods.SQL import SQL
from Globals import PersistentMapping
from Globals import Persistent
from Globals import HTMLFile, MessageDialog, DTMLFile
import time
from DateTime import DateTime
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from Acquisition import Implicit
from Globals import Persistent
from AccessControl.Role import RoleManager
from OFS.Folder import Folder

manage_addSempoiCalendarForm = DTMLFile('dtml/addSempoiCalendar',globals())
def manage_addSCalendar(self, id, conn_id, title, REQUEST=None):
	"""
	add SempoiCalendar instance
	"""

	ob = SempoiCalendar(id, conn_id, title)
	self._setObject(id,ob)
	if REQUEST:
		return self.manage_main(self,REQUEST)

class SempoiCalendar(Implicit, Persistent, RoleManager, Folder):
	"""my class"""
	
	meta_type = 'Sempoi Calendar'
	
	manage_options = ( {'label':'Contents','action':'manage_main'},
				{'label':'Posts','action':'manage_post'},
				{'label':'View','action':'index_html'},
				{'label':'Edit','action':'manage_edit'},
				{'label':'Properties','action':'manage_propertiesForm'},
			  	) +RoleManager.manage_options 
			
	_properties = ( {'id':'leftbgcolor','type':'string','mode':'w'},
			{'id':'middlebgcolor','type':'string','mode':'w'},
			{'id':'rightbgcolor','type':'string','mode':'w'},
			{'id':'cellbgcolor','type':'string','mode':'w'},
			{'id':'daybgcolor','type':'string','mode':'w'},
			{'id':'mhbgcolor','type':'string','mode':'w'},
			{'id':'align','type':'string','mode':'w'},
			{'id':'valign','type':'string','mode':'w'},
			{'id':'left','type':'string','mode':'w'},
			{'id':'middle','type':'string','mode':'w'},
			{'id':'right','type':'string','mode':'w'},
			{'id':'rightmiddle','type':'string','mode':'w'},
			#{'id':'daynames','type':'string','mode':'w'},
			{'id':'bordercolor','type':'string','mode':'w'},
			{'id':'spacing','type':'int','mode':'w'},
			{'id':'padding','type':'int','mode':'w'},
			{'id':'bgcolor','type':'string','mode':'w'},
			{'id':'todaycolor','type':'string','mode':'w'},
			{'id':'eventcolor','type':'string','mode':'w'},
			#{'id':'lang','type':'selection','select_variable' : 'lang_sel','mode':'w'},
			#{'id':'modes','type':'multiple selection','select_variable' : 'modes_sel','mode':'w'},
			{'id':'cat_list','type':'lines','mode':'w'},
			)

	security=ClassSecurityInfo()

	security.declareProtected('View Management Screens','manage_main')	
	security.declareProtected('View Management Screens','manage_post')	
	manage_post = DTMLFile('dtml/main',globals())		
	security.declareProtected('View Management Screens','manage_edit')	
	manage_edit = DTMLFile('dtml/edit',globals())
	security.declareProtected('View Management Screens','viewItem')	
	viewItem = DTMLFile('dtml/viewItem',globals())
	#manage_properties = DTMLFile('dtml/properties',globals())
	security.declarePublic('View','index_html')	
	def_index_html = DTMLFile('dtml/index',globals())
	#security.declareProtected('View Management Screens','add_borak')	
	#addItemForm = DTMLFile('dtml/addItemForm',globals())
	#security.declarePublic('View','formframe')	
	editForm = DTMLFile('dtml/editForm',globals())
	#security.declarePublic('View','chatframe')	
	#chatframe = DTMLFile('dtml/chatframe',globals())
	def_view = DTMLFile('dtml/view',globals())
	def_addForm = DTMLFile('dtml/addItemForm',globals())
	
	
	def __init__(self,id,conn_id, title=''):
		"""my init"""
		self.id = id
		self.title = title
		self.conn_id = conn_id
		self.anon = 'y'
		#calendaar attrib
		self.c = "#ffffff"
		self.leftbgcolor = "#000000"
		self.middlebgcolor = "#ffffff"
		self.rightbgcolor = "#ffffff"
		self.cellbgcolor = "#ffffff"
		self.daybgcolor = "#ffffff"
		self.mhbgcolor = "#ffffff"
		self.align = 'center'
		self.valign = 'top'
		self.left = ''
		self.middle  = ''
		self.right = ''
		self.rightmiddle = ''
		#self.daynames = 'SMTWTFS'
		self.bordercolor = '#000000'
		self.spacing = 2
		self.padding = 4
		self.bgcolor = "#ffffff"
		self.todaycolor = '#ff00ee'
		self.eventcolor = '#44ffee'
		#self.lang = 'en'
		#self.modes = ''
		self.cat_list = ''
		self.sqlAddItem = SQL('sqlAddItem','',self.conn_id,
			'obj_id bodytext username title category start_date end_date start_event end_event status',
				 _sqlAddItem)
		self.sqlGetItem = SQL('sqlGetItem','',self.conn_id,
					'start_date',_sqlGetItem)
		self.sqlGetAllItems = SQL('sqlGetAllItems','',self.conn_id,
					'',_sqlGetAllItems)
		self.sqlGetObj_id = SQL('sqlGetObj_id','',self.conn_id,
					'obj_id',_sqlGetObj_id)
		self.sqlUpdateItem = SQL('sqlUpdateItem','',self.conn_id,
				'obj_id bodytext username title category start_date end_date start_event end_event status',
				_sqlUpdateItem)	
		self.sqlDelItem = SQL('sqlDelItem','',self.conn_id, 'obj_id', _sqlDelItem)
		#copy default dtml
		Folder.manage_addDTMLMethod(self,'index_html',file=self.def_index_html,REQUEST=None)
		Folder.manage_addDTMLMethod(self,'view',file=self.def_view,REQUEST=None)
		Folder.manage_addDTMLMethod(self,'addItemForm',file=self.def_addForm,REQUEST=None)
	
	def lang_sel(self):
		"""return avail lang"""
		lang = ['en','de','it']
		return lang

	def modes_sel(self):
		"""return avail modes"""
		modes = ['day','week','month','year']
		return modes

	security.declareProtected('Add SempoiCalendar Item','addItem')	
	def addItem(self,bodytext, username, title, category, 
		start_date, end_date, start_event, end_event, status, REQUEST=None):
		"""add message"""
		u = REQUEST.AUTHENTICATED_USER.getUserName()
		if self.anon == 'n' and u != username:
			return """something wrong"""
		if start_date and end_date:
			e_d = DateTime(end_date)
			s_d = DateTime(start_date)
			delta = int((e_d - s_d) + 1)
			if delta > 29:
				return """cannot exceed 30 days"""
			
			for i in range(0,delta):
				obj_id = time.time()
				s_date = DateTime(start_date) + i
				self.sqlAddItem(obj_id=obj_id, bodytext=bodytext, 
						username=username, title=title, category=category, 
						start_date=s_date, end_date=end_date, start_event=start_event,
					 	end_event=end_event, status=status)
				#print s_date
			return self.REQUEST.RESPONSE.redirect('index_html')
		else:
			obj_id = time.time()
			#if bodytext:
			self.sqlAddItem(obj_id=obj_id, bodytext=bodytext, 
				username=username, title=title, category=category, 
				start_date=start_date, end_date=end_date, start_event=start_event,
				 end_event=end_event, status=status)
		return self.REQUEST.RESPONSE.redirect('index_html')

	def getItem(self,start_date):
		"""return all items"""
		#alldata =[]
		#try:
		items = self.sqlGetItem(start_date=start_date)
		return items

	def getAllItems(self):
		"""get all items"""
		items = self.sqlGetAllItems()
		return items

	def delItem(self,obj_ids,REQUEST=None):
		"""delete item"""
		print obj_ids
		for obj_id in obj_ids:
			self.sqlDelItem(obj_id=obj_id)
		return self.manage_post(REQUEST,management_view='Posts',
                      				manage_tabs_message='Items deleted')

	def getObj_id(self,obj_id):
		"""get item by obj_id"""
		items = self.sqlGetObj_id(obj_id=obj_id)
		return items

	def updateItem(self, obj_id, bodytext, username, title, category, 
		start_date, end_date, start_event, end_event, status, REQUEST=None):
		"""update events"""
		u = REQUEST.AUTHENTICATED_USER.getUserName()
		if u == username:
			self.sqlUpdateItem(obj_id=obj_id, bodytext=bodytext, 
				username=username, title=title, category=category, 
				start_date=start_date, end_date=end_date, start_event=start_event,
				 end_event=end_event, status=status)
			return self.REQUEST.RESPONSE.redirect('index_html')

	def manage_editSempoiCalendar(self,conn_id,anon='y',title='',REQUEST=None):
		"""edit instance"""
		self.title=title
		self.conn_id= conn_id
		self.anon = anon
		if REQUEST:
			return self.manage_main(REQUEST)

	def enumQueries(self):
        	list=[]
        	type=SQL.meta_type
        	for ob in self.__dict__.values():
            		if hasattr(ob, 'meta_type') and ob.meta_type==type:
                		list.append(ob)
        	return list

	def enumDocuments(self):
        	list=[]
        	type=Document.meta_type
        	for ob in self.__dict__.values():
            		if hasattr(ob, 'meta_type') and ob.meta_type==type:
                		list.append(ob)
        	return list

	



import Missing
mt=type(Missing.Value)

def typeconv(val):
    if type(val)==mt:
        return ''
    return val

def sqlattr(ob, attr):
    name=attr
    if hasattr(ob, attr):
        return typeconv(getattr(ob, attr))
    attr=upper(attr)
    if hasattr(ob, attr):
        return typeconv(getattr(ob, attr))
    attr=lower(attr)
    if hasattr(ob, attr):
        return typeconv(getattr(ob, attr))
    raise NameError, name

def absattr(attr):
    if callable(attr): return attr()
    return attr

def reqattr(request, attr):
    try:    return request[attr]
    except: return None

_sqlAddItem = """
	insert into calendar 
	(obj_id,
	bodytext,
	username, title,
	category, start_date, end_date,
	start_event, end_event, status
	)
	VALUES (<dtml-sqlvar obj_id type=float>,
		<dtml-sqlvar bodytext type=string>,
		<dtml-sqlvar username type=string>,
		<dtml-sqlvar title type=string>,
		<dtml-sqlvar category type=string>,
		<dtml-sqlvar start_date type=string>,
		<dtml-sqlvar end_date type=string>,
		<dtml-sqlvar start_event type=string>,
		<dtml-sqlvar end_event type=string>,
		<dtml-sqlvar status type=string>)	
	"""

_sqlGetItem = """
	select * from calendar 
	where <dtml-sqltest start_date type=string> 
		"""

_sqlGetAllItems = """
	select * from calendar 
		"""
_sqlGetObj_id = """
	select * from calendar 
	where <dtml-sqltest obj_id type=float> 
		"""
_sqlDelItem = """
	delete from calendar 
	where <dtml-sqltest obj_id type=float> 
		"""

_sqlUpdateItem = """
	update calendar set
	<dtml-sqltest bodytext type=string>,
		<dtml-sqltest username type=string>,
		<dtml-sqltest title type=string>,
		<dtml-sqltest category type=string>,
		<dtml-sqltest start_date type=string>,
		<dtml-sqltest end_date type=string>,
		<dtml-sqltest start_event type=string>,
		<dtml-sqltest end_event type=string>,
		<dtml-sqltest status type=string>
	where <dtml-sqltest obj_id type=float>
	"""



InitializeClass(SempoiCalendar)

""" schema
create table calendar (
obj_id float,
bodytext varchar(255),
username varchar(60),
title varchar(60),
category varchar(40),
start_date varchar(20),
end_date varchar(20),
start_event varchar(20),
end_event varchar(20),
status varchar(10)
)
"""
